/*
 * global variables for htool 2.x
 *
 * $Id: global.h,v 1.1 1994/02/17 20:21:59 moore Exp $
 *
 * $Log: global.h,v $
 * Revision 1.1  1994/02/17  20:21:59  moore
 * Initial revision
 *
 */

#ifdef __
#undef __
#endif
#if defined(__STDC__) || defined(FUNCPROTO)
#define __(x) x
#else
#define __(x) ()
#endif

#include "trace_new.h"		/* for def'n of trace_time */

extern struct globals {
    Widget topLevel;
    XtAppContext context;
    Window rootWindow;
    int screen;
    Display *display;
    int displayWidth;
    int displayHeight;
    int depth;
    Pixel blackPixel;
    Pixel whitePixel;
    char homeDirectory[1024];	/* XXX is this used? */
    char currentDirectory[1024];
    char costFile[1024];
    char graphFile[1024];
    char traceFile[1024];
    struct text_sink *info_sink;
    struct text_sink *pvm_sink;
    Boolean inColor;
    struct graph *graph;	/* Graph for editing*/
    struct graph *traceGraph;	/* Graph for tracing */
    struct cost_matrix *costMatrix; /* cost matrix */
    int language;		/* XXX get rid of this somehow */
#define LANG_C		1
#define LANG_FORTRAN	2
    int mode;
#define MODE_COMPOSE	1	/* compose/build */
#define MODE_EXECUTE	2	/* execute */
#define MODE_TRACE	3	/* post-mortem trace */
#define MODE_BUILD	4
    struct event_time traceClock;
    int traceSequence;
} global;

extern struct defaults {
    Boolean monochrome;
    Pixel titleBackground;
    Pixel titleForeground;

    Pixel brokenColor;
    Pixel deadColor;
    Pixel disabledColor;
    Pixel doneColor;
    Pixel errorColor;
    Pixel exitColor;
    Pixel idleColor;
    Pixel normalColor;
    Pixel notReadyColor;
    Pixel readyColor;
    Pixel runningColor;
    Pixel warningColor;
    /*
     * these are set by lines in ~/.htool, not by X resources.
     */
    char *editorCommand;	/* .htool */
    char *language;		/* .htool */
    char *printCommand;		/* .htool */
    char *pvmHostFile;		/* .htool */
    char *subDefsFile;		/* .htool */
    char *tmpDir;		/* .htool */

    Boolean debugMaster;	/* true if executioner is to be debugged */
} defaults;

typedef struct {
    Pixmap pm;
    int width;
    int height;
} *Pix;

extern struct pix {
    /* pixmaps for drawing normal nodes */
    Pix done;
    Pix dead;
    Pix error;
    Pix notReady;
    Pix ready;
    Pix running1;
    Pix running2;
    Pix warning;
    /* pixmaps for drawing special nodes */
    Pix beginLoop;
    Pix endLoop;
    Pix beginSwitch;
    Pix endSwitch;
    Pix beginPipe;
    Pix endPipe;
    Pix fanOut;
    Pix fanIn;
} pix;

#undef __
